#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "resource.h"
//#include "resource\BGFont.h"
//#include "resource\BitMapFont.h"

//---------------------------------------------------------------------------
#define LOCATE_X     5
#define LOCATE_Y     5
#define MIRROR_CX   40
#define MIRROR_CY   40
#define MIRROR_SIZE (MIRROR_CX * MIRROR_CY * 2)
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
u16 GraphBuffer[sample_img_size/2]   IN_EWRAM;
u16 GraphBufferMirror[MIRROR_SIZE/2] IN_EWRAM;

s16 GrapX;
s16 GrapY;
s16 MoveX;
s16 MoveY;
//---------------------------------------------------------------------------
void Init();

void CopyGraphBuffer();

void DrawLeftUp();
void DrawLeftDown();
void DrawRightUp();
void DrawRightDown();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	SetMode(MODE_3 | BG2_ENABLE);

	CopyGraphBuffer();

	for(;;)
	{
		WaitForVsync();
		
		DrawLeftUp();
		DrawLeftDown();
		DrawRightUp();
		DrawRightDown();
		
		CopyGraphBuffer();
	}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	REG_WSCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT;

	//摜f[^EWRAM̈ɃRs[
	DMA3MemcpyINC32((u32)&sample_img_bin, (u32)&GraphBuffer, sample_img_size/4);

	GrapX = 0;
	GrapY = 0;
	MoveX = 1;
	MoveY = 1;
}
//---------------------------------------------------------------------------
void CopyGraphBuffer()
{
	GrapX += MoveX;
	GrapY += MoveY;

	if (GrapX <= 0 || GrapX >= (240-MIRROR_CX) ) MoveX *= -1;
	if (GrapY <= 0 || GrapY >= (160-MIRROR_CY) ) MoveY *= -1;

	s16 x,y;
	for(y=0; y<MIRROR_CY; y++)
	{
		for(x=0; x<MIRROR_CX; x++)
		{
			GraphBufferMirror[y*MIRROR_CX+x] = GraphBuffer[(y+GrapY)*SCREEN_CX+(x+GrapX)];
		}
	}
}
//---------------------------------------------------------------------------
void DrawLeftUp()
{
	u16* Screen = VideoBuffer;
	u16  x,y;

	Screen += LOCATE_Y * SCREEN_CX + LOCATE_X;

	for(y=0; y<MIRROR_CY; y++)
	{
		for(x=0; x<MIRROR_CX; x++)
		{
			Screen[y*SCREEN_CX+x] = GraphBufferMirror[y*MIRROR_CX+x];
		}
	}
}
//---------------------------------------------------------------------------
void DrawLeftDown()
{
	u16* Screen = VideoBuffer;
	u16  x,y;

	Screen += LOCATE_Y  * SCREEN_CX + LOCATE_X;
	Screen += MIRROR_CY * SCREEN_CX + 0;

	for(y=0; y<MIRROR_CY; y++)
	{
		for(x=0; x<MIRROR_CX; x++)
		{
			Screen[y*SCREEN_CX+x] = GraphBufferMirror[(MIRROR_CY-y)*MIRROR_CX+x];
		}
	}
}
//---------------------------------------------------------------------------
void DrawRightUp()
{
	u16* Screen = VideoBuffer;
	u16  x,y;

	Screen += LOCATE_Y  * SCREEN_CX + LOCATE_X;
	Screen += 0 * SCREEN_CX + MIRROR_CX;

	for(y=0; y<MIRROR_CY; y++)
	{
		for(x=0; x<MIRROR_CX; x++)
		{
			Screen[y*SCREEN_CX+x] = GraphBufferMirror[y*MIRROR_CX+(MIRROR_CX-x)];
		}
	}
}
//---------------------------------------------------------------------------
void DrawRightDown()
{
	u16* Screen = VideoBuffer;
	u16  x,y;

	Screen += LOCATE_Y  * SCREEN_CX + LOCATE_X;
	Screen += MIRROR_CY * SCREEN_CX + MIRROR_CX;

	for(y=0; y<MIRROR_CY; y++)
	{
		for(x=0; x<MIRROR_CX; x++)
		{
			Screen[y*SCREEN_CX+x] = GraphBufferMirror[(MIRROR_CY-y)*MIRROR_CX+(MIRROR_CX-x)];
		}
	}
}
